#include <Array.au3>
#include <GuiListView.au3>
#include <WindowsConstants.au3>
#include <ListViewConstants.au3>
#include <GUIConstantsEx.au3>
#include "zlib.au3"

$sTitle = 'ZAX UnPacker v1.1    ;-)'

If Not _Zlib_Startup(@ScriptDir & "\zlib1.dll") Then Exit MsgBox(48, $sTitle, "Konnte zlib1.dll nicht finden...")

$hGui = GUICreate($sTitle, 740, 600, -1, -1, Default, $WS_EX_ACCEPTFILES)

$hPack = GUICtrlCreateButton('Packen', 10, 10, 80, 25)
$hPackPath = GUICtrlCreateInput(@ScriptDir & '\archiv.zax', 100, 11, 600, 23)
$hPackSelect = GUICtrlCreateButton('...', 700, 10, 30, 25)

$hPackProgress = GUICtrlCreateProgress(10, 40, 720, 10)

$hPackListview = GUICtrlCreateListView('Dateiname|Gre|Pfad', 10, 60, 720, 220, BitOR($LVS_SHOWSELALWAYS, $LVS_NOSORTHEADER))
$hPackContext = GUICtrlCreateContextMenu($hPackListview)
$hPackClear = GUICtrlCreateMenuItem('Packliste leeren', $hPackContext)
$hPackAll = GUICtrlCreateMenuItem('Alle Dateien auswhlen', $hPackContext)
GUICtrlSetState($hPackListview, $GUI_DROPACCEPTED)
GUICtrlSendMsg($hPackListview, $LVM_SETCOLUMNWIDTH, 0, 200)
GUICtrlSendMsg($hPackListview, $LVM_SETCOLUMNWIDTH, 1, 80)
GUICtrlSendMsg($hPackListview, $LVM_SETCOLUMNWIDTH, 2, 430)

$hUnPack = GUICtrlCreateButton('Entpacken', 10, 310, 80, 25)
$hUnPackPath = GUICtrlCreateInput(@ScriptDir & '\entpackt\', 100, 311, 600, 23)
$hUnpackSelect = GUICtrlCreateButton('...', 700, 310, 30, 25)

$hUnPackProgress = GUICtrlCreateProgress(10, 340, 720, 10)

$hUnPackListview = GUICtrlCreateListView('Dateiname|Gre|Archiv|Offset|gepackte Gre|relativer Pfad', 10, 360, 720, 220, BitOR($LVS_SHOWSELALWAYS, $LVS_NOSORTHEADER))
$hUnPackContext = GUICtrlCreateContextMenu($hUnPackListview)
$hUnPackClear = GUICtrlCreateMenuItem('Entpackliste leeren', $hUnPackContext)
$hUnPackAll = GUICtrlCreateMenuItem('Alle Dateien auswhlen', $hUnPackContext)
GUICtrlSetState($hUnPackListview, $GUI_DROPACCEPTED)
GUICtrlSendMsg($hUnPackListview, $LVM_SETCOLUMNWIDTH, 0, 200)
GUICtrlSendMsg($hUnPackListview, $LVM_SETCOLUMNWIDTH, 1, 80)
GUICtrlSendMsg($hUnPackListview, $LVM_SETCOLUMNWIDTH, 2, 350)
GUICtrlSendMsg($hUnPackListview, $LVM_SETCOLUMNWIDTH, 3, 80)
GUICtrlCreateLabel(ChrW(0xA9) & " 2009 by Oscar und Prog@ndy.         -         ZLib-Version: " & _ZLib_Version(), 10, 585, 720, 15)
GUISetState()
WinSetOnTop($hGui, '', 1)

Global $gaDropFiles[1]
Global Const $WM_DROPFILES = 0x233
GUIRegisterMsg($WM_DROPFILES, '_WM_DROPFILES')

While True
    Switch GUIGetMsg()
        Case $GUI_EVENT_CLOSE
            Exit
        Case $GUI_EVENT_DROPPED
            _DropFiles()
        Case $hPackSelect
            _ChooseDestFile()
        Case $hUnpackSelect
            _ChooseDestFolder()
        Case $hPack
            _PackFiles()
        Case $hUnPack
            _UnpackFiles()
        Case $hPackClear
            _GUICtrlListView_DeleteAllItems($hPackListview)
            GUICtrlSetData($hPackProgress, 0)
        Case $hUnPackClear
            _GUICtrlListView_DeleteAllItems($hUnPackListview)
            GUICtrlSetData($hUnPackProgress, 0)
        Case $hPackAll
            _GUICtrlListView_SetItemSelected($hPackListview, -1, True)
        Case $hUnPackAll
            _GUICtrlListView_SetItemSelected($hUnPackListview, -1, True)
    EndSwitch
WEnd

Func _ChooseDestFile()
    Local $sPath
    $sPath = FileSaveDialog('Datei zum packen auswhlen', '', 'Archiv (*.zax)', 16, '', $hGui)
    If @error Then Return
    $sPath = StringRegExpReplace($sPath & '.zax', '(.+\\.+?)\..+', '$1' & '.zax')
    GUICtrlSetData($hPackPath, $sPath)
EndFunc   ;==>_ChooseDestFile

Func _ChooseDestFolder()
    Local $sPath
    $sPath = FileSelectFolder('Verzeichnis zum entpacken whlen', '', 3, '', $hGui)
    If @error Then Return
    GUICtrlSetData($hUnPackPath, $sPath)
EndFunc   ;==>_ChooseDestFolder

Func _PackFiles()
    Local $sWritePath, $hWriteFile, $aSelected, $sReadPath, $hReadFile, $sBuffer, $hTempWriteFile
    $sWritePath = GUICtrlRead($hPackPath) ; Speicherpfad holen
    If $sWritePath = '' Then Return MsgBox(48 + 262144, 'Fehler', 'keine Archivdatei ausgewhlt') ; wenn nicht ausgewhlt, dann Funktion verlassen
    $aSelected = _GUICtrlListView_GetSelectedIndices($hPackListview, True) ; Markierte Listview-Eintrge holen
    If $aSelected[0] = 0 Then Return MsgBox(48 + 262144, 'Fehler', 'keine Dateien zum packen ausgewhlt') ; wenn nicht ausgewhlt, dann Funktion verlassen
    $hWriteFile = FileOpen($sWritePath, 2 + 8 + 16) ; Archivdatei im Binrmodus zum speichern ffnen
    If $hWriteFile <> -1 Then ; wenn erfolgreich, dann...
        GUICtrlSetState($hPack, $GUI_DISABLE)
        Local $sTempWritePath = $sWritePath&".tmp"
        GUICtrlSetData($hPackProgress, 1) ; Progressbar aktualisieren
        FileWrite($hWriteFile, 'zax|') ; Dateikennung schreiben
        $hTempWriteFile = FileOpen($sTempWritePath, 26)
        FileSetAttrib($sTempWritePath,"+HT")
		Local $aReadPaths[$aSelected[0]]
		For $i = 1 To $aSelected[0]
			$aReadPaths[$i-1] = _GUICtrlListView_GetItemText($hPackListview, $aSelected[$i], 2) ; den Pfad holen
		Next
		Local $aCommonPaths = _FileGetCommonPath($aReadPaths)
        For $i = 1 To $aSelected[0] ; Header erstellen (alle Listview-Eintrge durchgehen)
            FileWrite($hWriteFile, _GUICtrlListView_GetItemText($hPackListview, $aSelected[$i], 1) & '|') ; Dateigre
            FileWrite($hWriteFile, _GUICtrlListView_GetItemText($hPackListview, $aSelected[$i], 0) & '|') ; Dateiname
            ; die Datei komprimieren und temporr speichern
            $sReadPath = $aReadPaths[$i-1]
            $hReadFile = FileOpen($sReadPath, 16) ; Datei im Binrmodus zum lesen ffnen
            $sBuffer = FileRead($hReadFile) ; Datei lesen
            $sBuffer = _Zlib_CompressBinary($sBuffer)
            FileClose($hReadFile) ; Datei schliessen
            FileWrite($hTempWriteFile, $sBuffer) ; Datei ins Archiv schreiben
            GUICtrlSetData($hPackProgress, 1 + (90 / $aSelected[0] * $i)) ; Progressbar aktualisieren
            FileWrite($hWriteFile, BinaryLen($sBuffer) & '|') ; komprimierte Dateigre
			Switch IsArray($aCommonPaths)
				Case False
					FileWrite($hWriteFile, _GUICtrlListView_GetItemText($hPackListview, $aSelected[$i], 0) & '|') ; komprimierte Dateigre
				Case True
					If $aCommonPaths[0]="" Then $aCommonPaths[$i] = StringRegExpReplace($aCommonPaths[$i],"\A([a-zA-Z]):\\", "LW_\1\\")
					FileWrite($hWriteFile, $aCommonPaths[$i] & '|') ; komprimierte Dateigre
			EndSwitch
        Next
        ;GUICtrlSetData($hPackProgress, 3) ; Progressbar aktualisieren
        FileWrite($hWriteFile, 'end') ; Header-Ende-kennung schreiben
        FileClose($hTempWriteFile)
        ; Dateien an das Archiv anhngen
        $hReadFile = FileOpen($sTempWritePath, 16)
        Do
            $sBuffer = FileRead($hReadFile, 10485760)
            If @error Then ExitLoop
            FileWrite($hWriteFile, $sBuffer)
        Until @error
        FileClose($hReadFile)
        FileDelete($sTempWritePath)
        GUICtrlSetData($hPackProgress, 100) ; Progressbar aktualisieren
        FileClose($hWriteFile) ; Archivdatei schliessen
        Beep(800, 100)
        Sleep(500)
        GUICtrlSetState($hPack, $GUI_ENABLE)
        GUICtrlSetData($hPackProgress, 0)
    EndIf
EndFunc   ;==>_PackFiles

Func _UnpackFiles()
    Local $sOutFolder, $aSelected, $hFile, $sReadPath, $iOffset, $sFileName, $iFileSize, $sFile, $iCompressedSize
    $sOutFolder = GUICtrlRead($hUnPackPath) ; Entpackverzeichnis holen
    If $sOutFolder = '' Then Return MsgBox(48 + 262144, 'Fehler', 'kein Entpackverzeichnis ausgewhlt') ; wenn nicht ausgewhlt, dann Funktion verlassen
    $aSelected = _GUICtrlListView_GetSelectedIndices($hUnPackListview, True) ; Markierte Listview-Eintrge holen
    If $aSelected[0] = 0 Then Return MsgBox(48 + 262144, 'Fehler', 'keine Dateien zum entpacken ausgewhlt') ; wenn nicht ausgewhlt, dann Funktion verlassen
    GUICtrlSetState($hUnPack, $GUI_DISABLE)
    If StringRight($sOutFolder, 1) <> '\' Then $sOutFolder &= '\' ; Backslash anfgen, wenn nicht vorhanden
    For $i = 1 To $aSelected[0] ; alle markierten Eintrge durchgehen
        $sFileName = _GUICtrlListView_GetItemText($hUnPackListview, $aSelected[$i], 0) ; Dateinamen holen
        $iFileSize = _GUICtrlListView_GetItemText($hUnPackListview, $aSelected[$i], 1) ; Dateigre
        $sReadPath = _GUICtrlListView_GetItemText($hUnPackListview, $aSelected[$i], 2) ; Archivdatei
        $iOffset = _GUICtrlListView_GetItemText($hUnPackListview, $aSelected[$i], 3) ; Offset zur Datei
        $iCompressedSize = _GUICtrlListView_GetItemText($hUnPackListview, $aSelected[$i], 4) ; komprimierte Gre
        $sPath = _GUICtrlListView_GetItemText($hUnPackListview, $aSelected[$i], 5) ; relativer Pfad
        ConsoleWrite($i & ' = >' & $sFileName & '<' & @CR)
        $hFile = FileOpen($sReadPath, 16) ; Archivdatei im Binrmodus zu lesen ffnen
        If $hFile <> -1 Then ; wenn erfolgreich, dann...
            FileRead($hFile, $iOffset) ; Dateizeiger auf den Offset setzen
            $sFile = FileRead($hFile, $iCompressedSize) ; Datei aus dem Archiv auslesen
            FileClose($hFile) ; Archivdatei schliessen
            $sFile = _Zlib_UncompressBinary($sFile, $iFileSize)
            $hFile = FileOpen($sOutFolder & $sPath, 2 + 8 + 16) ; Datei im Entpackverzeichnis erstellen und zum schreiben ffnen
            If $hFile <> -1 Then ; wenn erfolgreich, dann...
                FileWrite($hFile, $sFile) ; Dateiinhalt schreiben
                FileClose($hFile) ; Datei schliessen
            EndIf
        EndIf
        GUICtrlSetData($hUnPackProgress, 100 / $aSelected[0] * $i) ; Progressbar aktualisieren
    Next
    Beep(800, 100)
    Sleep(500)
    GUICtrlSetState($hUnPack, $GUI_ENABLE)
    GUICtrlSetData($hUnPackProgress, 0)
EndFunc   ;==>_UnpackFiles

Func _WM_DROPFILES($hWnd, $msgID, $wParam, $lParam)
    Local $nSize, $pFileName
    Local $nAmt = DllCall('shell32.dll', 'int', 'DragQueryFileW', 'hwnd', $wParam, 'int', 0xFFFFFFFF, 'ptr', 0, 'int', 255)
    For $i = 0 To $nAmt[0] - 1
        $nSize = DllCall('shell32.dll', 'int', 'DragQueryFileW', 'hwnd', $wParam, 'int', $i, 'ptr', 0, 'int', 0)
        $nSize = $nSize[0] + 1
        $pFileName = DllStructCreate('wchar[' & $nSize & ']')
        DllCall('shell32.dll', 'int', 'DragQueryFileW', 'hwnd', $wParam, 'int', $i, 'ptr', DllStructGetPtr($pFileName), 'int', $nSize)
        ReDim $gaDropFiles[$i + 1]
        $gaDropFiles[$i] = DllStructGetData($pFileName, 1)
        $pFileName = 0
    Next
    Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_DROPFILES

Func _DropFiles()
    For $i = 0 To UBound($gaDropFiles) - 1
        If FileRead($gaDropFiles[$i], 4) = 'zax|' Then
			If StringRight($gaDropFiles[$i],4) = ".zax" Or _
				MsgBox(36+262144, $sTitle, "Folgende Datei knnte eine ZAX-Archivdatei sein, obwohl sie eine flashce Endung hat: " & @CRLF & _
								$gaDropFiles[$i] & @CRLF & @CRLF & _
								"Soll sie als ZAX-Archiv behandelt werden?"	)=6 _
			Then
				_DropUnPack($gaDropFiles[$i])
			Else
				_DropPack($gaDropFiles[$i])
			EndIf
        Else
            _DropPack($gaDropFiles[$i])
        EndIf
    Next
EndFunc   ;==>_DropFiles

Func _DropPack($sDropFile)
    Local $sFilePath, $sFileName, $sFileSize, $aFiles
	Local $iCount = _GUICtrlListView_GetItemCount($hPackListview), $aPaths[$iCount+1]
	For $i = 0 To $iCount-1
		$aPaths[$i] = _GUICtrlListView_GetItemText($hPackListview,$i,2)
	Next
    If StringInStr(FileGetAttrib($sDropFile), 'D') Then
        $aFiles = _RecursiveFileListToArray($sDropFile, '.+', 1)
        For $i = 1 To $aFiles[0]
			If _ArraySearch($aPaths,$aFiles[$i])<>-1 Then ContinueLoop
            $sFilePath = StringLeft($sDropFile, StringInStr($sDropFile, '\', 0, -1))
            $sFileName = StringTrimLeft($aFiles[$i], StringLen($sFilePath))
            $sFileSize = FileGetSize($aFiles[$i])
            GUICtrlCreateListViewItem($sFileName & '|' & $sFileSize & '|' & $aFiles[$i], $hPackListview)
        Next
    Else
		If _ArraySearch($aPaths,$sDropFile)<>-1 Then Return
        $sFileName = StringTrimLeft($sDropFile, StringInStr($sDropFile, "\", 0, -1))
        $sFileSize = FileGetSize($sDropFile)
        GUICtrlCreateListViewItem($sFileName & '|' & $sFileSize & '|' & $sDropFile, $hPackListview)
    EndIf
EndFunc   ;==>_DropPack

Func _DropUnPack($sDropFile)
    Local $hFile, $sHeader, $aHeader, $iOffset

	_DeleteFromUnpackLV($sDropFile)

    $hFile = FileOpen($sDropFile, 16)
    If $hFile <> -1 Then
        FileRead($hFile, 4)
        $sHeader = ''
        $iOffset = 4
        Do
            $iOffset += 1
            $sHeader &= BinaryToString(FileRead($hFile, 1))
        Until StringRight($sHeader, 4) = '|end'
        FileClose($hFile)
        $aHeader = StringSplit(StringTrimRight($sHeader, 4), '|', 2)
		Local $ubound = UBound($aHeader)
		If $ubound = 0 Or Mod($ubound,4)<>0 Then
			MsgBox(48+262144, $sTitle, "Folgende Datei ist kein gltiges ZAX-Archiv, obwohl sie so aussieht: " & @CRLF & $sDropFile)
			Return
		EndIf
        For $j = 0 To UBound($aHeader) - 1 Step 4
            GUICtrlCreateListViewItem($aHeader[$j + 1] & '|' & $aHeader[$j] & '|' & $sDropFile & '|' & $iOffset & '|' & $aHeader[$j+2]& '|' & $aHeader[$j+3], $hUnPackListview)
            $iOffset += $aHeader[$j+2]
        Next
		If FileGetSize($sDropFile)<$iOffset Then
			_DeleteFromUnpackLV($sDropFile)
			MsgBox(48+262144, $sTitle, "Folgende Datei ist kein gltiges ZAX-Archiv, obwohl sie so aussieht: " & @CRLF & $sDropFile)
			Return
		EndIf
    EndIf
EndFunc   ;==>_DropUnPack

Func _DeleteFromUnpackLV($sDropFile)
	Local $iCount = _GUICtrlListView_GetItemCount($hUnPackListview)
	_GUICtrlListView_BeginUpdate($hUnPackListview)
	For $i = $iCount-1 To 0 Step -1
		If $sDropFile = _GUICtrlListView_GetItemText($hUnPackListview,$i,2) Then
			_GUICtrlListView_DeleteItem($hUnPackListview,$i)
		EndIf
	Next
	_GUICtrlListView_EndUpdate($hUnPackListview)
EndFunc

;===============================================================================
;
; Function Name:   _FileGetCommonPath
; Description::    Takes an Array of files and returns the common Path
; Parameter(s):    $arFiles   - the array of files
;                  $AddBSlash - [optional] add a backslash to the common path (default = False)
; Requirement(s):
; Return Value(s): Array: array[0] contains the common path
;                         array[i] contains the remains of the paths
;                  If only 1 file given: the file as String
;                  Error: 0 and sets @error:
;                            1 - not an Array
; Author(s):       Prog@ndy
;
;===============================================================================
;
Func _FileGetCommonPath($arFiles,$AddBSlash=False, $RemoveDrive=False)
    If Not IsArray($arFiles) Then Return SetError(1,0,0)
    If UBound($arFiles)=1 Then Return $arFiles[0]
    For $i = 0 To UBound($arFiles)-1
        $arFiles[$i] = StringReplace($arFiles[$i],"/","\")
		If $RemoveDrive Then $arFiles[$i] = StringRegExpReplace($arFiles[$i],"\A([a-zA-Z]):\\","")
    Next
    Local $Letters = StringSplit($arFiles[0],"\"),$CommonPath,$Len,$Pos=1,$Part,$PartLen
    For $i = 1 To UBound($Letters)-1
        $Len = StringLen($Letters[$i])
        ;ConsoleWrite($Letters[$i] & @CRLF)
        For $j=1 To UBound($arFiles)-1
            ;ConsoleWrite(StringMid($arFiles[$j],$Pos,$Len) & @CRLF)
            $Part = StringMid($arFiles[$j],$Pos,$Len+1)
            $PartLen = StringLen($Part)
            Select
                Case $PartLen <= $Len
                    ExitLoop 2
                Case $Part <> ($Letters[$i]&"\")
                    ExitLoop 2
            EndSelect
        Next
        $CommonPath &= $Letters[$i]&"\"
        $Pos += $Len+1
    Next
    ReDim $arFiles[UBound($arFiles)+1]
    For $i = UBound($arFiles)-2 To 0 Step -1
        $arFiles[$i+1] = StringTrimLeft($arFiles[$i],StringLen($CommonPath))
    Next
    If $AddBSlash = False Then $CommonPath = StringTrimRight($CommonPath,1)
    $arFiles[0] = $CommonPath
    Return $arFiles
EndFunc


;===============================================================================
; Function Name:   _RecursiveFileListToArray($sPath[, $sPattern][, $iFlag][, $iFormat][, $iRecursion][, $sDelim])
; Description::    gibt Verzeichnisse und/oder Dateien (rekursiv) zurck, die einem RegExp-Pattern entsprechen
; Parameter(s):    $sPath = Startverzeichnis
;                  $sPattern = ein beliebiges RexExp-Pattern fr die Auswahl
;                  $iFlag = Auswahl
;                           0 = Dateien & Verzeichnisse
;                           1 = nur Dateien
;                           2 = nur Verzeichnisse
;                  $iFormat = Rckgabeformat
;                             0 = String
;                             1 = Array mit [0] = Anzahl
;                             2 = Nullbasiertes Array
;                  $iRecursion = Verzeichnisse rekursiv durchsuchen
;                                0 = Nein
;                                1 = Ja
;                  $sDelim = Trennzeichen fr die String-Rckgabe
; Requirement(s):  AutoIt 3.3.0.0
; Return Value(s): Array/String mit den gefundenen Dateien/Verzeichnissen
; Author(s):       Oscar (www.autoit.de)
;                  Anregungen von: bernd670 (www.autoit.de)
;===============================================================================
Func _RecursiveFileListToArray($sPath, $sPattern = '', $iFlag = 0, $iFormat = 1, $iRecursion = 1, $sDelim = @CRLF)
    Local $hSearch, $sFile, $sReturn = ''
    If StringRight($sPath, 1) <> '\' Then $sPath &= '\'
    $hSearch = FileFindFirstFile($sPath & '*.*')
    If @error Or $hSearch = -1 Then Return SetError(0, 0, $sReturn)
    While True
        $sFile = FileFindNextFile($hSearch)
        If @error Then ExitLoop
        If StringInStr(FileGetAttrib($sPath & $sFile), 'D') Then
            If StringRegExp($sPath & $sFile, $sPattern) And ($iFlag = 0 Or $iFlag = 2) Then $sReturn &= $sPath & $sFile & '\' & $sDelim
            If $iRecursion Then $sReturn &= _RecursiveFileListToArray($sPath & $sFile & '\', $sPattern, $iFlag, 0)
            ContinueLoop
        EndIf
        If StringRegExp($sFile, $sPattern) And ($iFlag = 0 Or $iFlag = 1) Then $sReturn &= $sPath & $sFile & $sDelim
    WEnd
    FileClose($hSearch)
    If $iFormat And $sReturn = '' Then Return StringSplit($sReturn, '', $iFormat)
    If $iFormat Then Return StringSplit(StringTrimRight($sReturn, StringLen($sDelim)), $sDelim, $iFormat)
    Return $sReturn
EndFunc   ;==>_RecursiveFileListToArray
